from loguru import logger
from datetime import datetime
from time import sleep
import json
from random import random, sample

TOPIC_PRE = "rd/set01"

def sendCmd(client, cmd):
    msg = {
        "ts": str(datetime.now()),
        "en": "EGM Test Experiment",
        "ec": "Lorem ipsum dolor sit amet",
        "es": cmd
    }
    topic = f"{TOPIC_PRE}/rig01/cmd"
    client.publish(topic, json.dumps(msg))
    logger.debug(topic)

def sendLog(client):
    msg = {
        "ts": str(datetime.now()),
        "v": [
            { "n": "v1", "v": random() },
            { "n": "v2", "v": random() },
            { "n": "v3", "v": random() },
            { "n": "v4", "v": random() },
            { "n": "v5", "v": random() },
            { "n": "v6", "v": random() },
        ]
    }
    topic = f"{TOPIC_PRE}/rig01/log"
    client.publish(topic, json.dumps(msg))
    logger.debug(topic)

def sendValue(client, device):
    msg = {
        "ts": str(datetime.now()),
        "dt": 100,
        "v": sample(range(0xffffffff), 3000)
    }
    topic = f"{TOPIC_PRE}/rig01/{device}/md"
    client.publish(topic, json.dumps(msg))
    logger.debug(topic)


def perform(client, params):
    logger.info("Start")
    sendCmd(client, "start")

    for i in range(300):
        sendValue(client, 'dev05')
        sendValue(client, 'dev06')
        sendLog(client)
        sleep(1.0)
    
    logger.info("Stop")
    sendCmd(client, "stop")
